<?php

/**
 * FapatMeHelper.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2019
 */

/**
 * Class FapatMeHelper
 *
 * http://fapat.me/img-589c7f24d6ab1.html
 * [post: continue to your image]
 * http://fapat.me/upload/big/2017/02/09/589c7f24d6a76.jpg
 *
 * looks like the form post needs to include imgContinue: "Continue+to+image+...+" as the POST param
 */
class FapatMeHelper extends BaseHelper
{

    /**
     * process
     * @param $uri
     * @return array Return array with 'image' and 'name' as the keys
     */
    public function process($uri) {
        $page = $this->postForm($uri);
        $info = $this->getImageInfo($page);
        $image['name'] = $info['name'] . '.jpg';
        $image['image'] = $this->getPage($info['link']);
        return $image;
    }

    public function postForm($uri) {
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL,$uri);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "imgContinue=Continue+to+image+...+");
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $server_output = curl_exec ($ch);

        curl_close ($ch);
        return $server_output;
    }

    /**
     * looking for this img HTML
     * <img class="centred" src="http://fapat.me/upload/big/2017/02/09/589c7f24d6a76.jpg" alt="femjoy_116267_085" style="max-width:1000px;">
     * @param $page
     * @return bool
     */
    public function getImageInfo($page) {
        $retval = false;
        $images = parse_array($page, '<img', '>');
        foreach ($images as $image) {
            if (strstr($image, 'http://fapat.me/upload/big')) {
                $retval['name'] = $this->getAttribute($image, 'alt');
                $retval['link'] = $this->getAttribute($image, 'src');
            }
        }
        return $retval;
    }
}