<?php
/**
 * ImgbabesComHelper.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2019
 */

/**
 * Class ImgbabesComHelper
 *
 * these thumbnail links: 
 * <a href="http://www.imgbabes.com/4lm518gdwknt/0.jpg.html" target="_blank"><img src="http://i.imgbabes.com/i/00389/4lm518gdwknt_t.jpg" border="0" alt="" /></a>
 *
 * point to an interim page:
 * http://www.imgbabes.com/4lm518gdwknt/0.jpg.html
 * which has some annoying javascript, which has this link in it:
 * http://www.imgbabes.com/4lm518gdwknt/0.jpg.html?attempt=1
 * 
 * looks like adding ?attempt=1 to the url for the thumb URI gets me to the detail page, which has:
 * <img src="http://i.imgbabes.com/files/2/d0qhnm3q5ip7rw/0 (1).jpg" class="pic" id="this_image" alt="0 (1).jpg"
 * which points to image: 
 * http://i.imgbabes.com/files/9/jfko1un011999c/0.jpg
 * <img src="http://i.imgbabes.com/files/9/futaekl4bh4xpd/0 (1).jpg" class="pic" id="this_image" alt="0 (1).jpg"
 * which points to image at URI: 
 * http://i.imgbabes.com/files/9/futaekl4bh4xpd/0%20(1).jpg
 */

/**
 * NOTE this helper isn't working
 * imgbabes.com presents a no-javascript version of the detail page
 * which doesn't have the information I need to get the image
 */
class ImgbabesComHelper extends BaseHelper
{
    /**
     * process
     * @param $uri
     * @return array Return array with 'image' and 'name' as the keys
     */
    public function process($uri) {
        $page = $this->getPage($uri .'?attempt=1');
//out($page);
//        $page = $this->getPage('test/detail.imgbabes.com.html');
        $info = $this->getImageInfo($page);
        $image['name'] = $info['name'];
        $image['image'] = $this->getPage($this->cleanUri($info['link']));
        return $image;
    }
    
    public function getImageInfo($html) {
        $fragment = parse_array($html, '<span id="zoomimage"', '</span>');
        if ($fragment) {
            $search = array('<span id="zoomimage" style="visibility:hidden">', '</span>');
            $replace = array('','');
            $fragment = str_replace($search, $replace, $fragment[0]); 
            $retval['link'] = $this->getAttribute($fragment, 'src');
            $retval['name'] = $this->getAttribute($fragment, 'alt');
        } else {
            $retval = null;
        }
        return $retval;
    }
    
    public function cleanUri($uri) {
        $retval = str_replace(' ', '%20', $uri);
        return $retval;
    }
}
?>

