<?php

/**
 * ImgchiliNetHelper.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2019
 */

/**
 * Class ImgchiliNetHelper
 *
 * http://imgchili.net/show/60554/60554375_308182_full.jpg
 * http://i10.imgchili.net/60554/60554375_308182_full.jpg
 *
 * http://imgchili.net/show/98728/98728125_femjoy_11375010_001.jpg
 * http://i11.imgchili.net/98728/98728125_femjoy_11375010_001.jpg
 */

class ImgchiliNetHelper extends BaseHelper
{

    /**
     * process
     * @param $uri
     * @return array Return array with 'image' and 'name' as the keys
     */
    public function process($uri) {
        $image['name'] = $this->getImageName($uri);
        $download = $this->makeDownloadUri($uri);
        $image['image'] = $this->getPage($download);
        return $image;
    }

    public function getImageName($uri) {
        $parts = parse_url($uri);
        $pieces = explode('/', $parts['path']);
        $name = array_pop($pieces);
        return $name;
    }

    /**
     * http://imgchili.net/show/60554/60554375_308182_full.jpg
     * http://i10.imgchili.net/60554/60554375_308182_full.jpg
     * @param $uri
     * @return mixed
     */
    public function makeDownloadUri($uri) {
        $prefix = $this->getPrefix($this->getImgSrc());
        $search = array("http://", "show/");
        $replace = array('http://i' . $prefix, '');
        $new = str_replace($search, $replace, $uri);
        return $new;
    }

    /**
     * receive something like:
     * http://t11.imgchili.net/98728/98728125_femjoy_11375010_001.jpg
     * and extract out the content between http:// and .imgchili
     * @param $string
     * @return string
     */
    public function getPrefix($string) {
        $start = 'http://t';
        $end = 'imgchili';
        $rs = return_between($string, $start, $end, EXCL);
        return $rs;
    }
}