<?php

/**
 * ImgtrexComHelper.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2019
 */

/**
 * Class ImgtrexComHelper
 * 
 * http://imgtrex.com/1i9k1b83fm2x/IC0848_015.jpg
 * <a href="http://raptor.imgtrex.com/i/02154/1i9k1b83fm2x.jpg" download="IC0848_015.jpg" target="_blank" id="showcmt" class="btn btn-default btn-xs"><i class="fa fa-download"></i> Download</a>
 *
 * http://imgtrex.com/anekxzqop857/IC0848_001.jpg
 * http://raptor.imgtrex.com/i/02154/anekxzqop857.jpg
 *
 */
class ImgtrexComHelper extends BaseHelper
{

    /**
     * process
     * @param $uri
     * @return array Return array with 'image' and 'name' as the keys
     */
    public function process($uri) {
        $page = $this->getPage($uri);
//        $image['name'] = $this->getImageName($uri);
        $image = $this->getImageInfo($page);
        $image['image'] = $this->getPage($image['link']);
        return $image;
    }

    public function getImageName($uri) {
        $parts = parse_url($uri);
        $pieces = explode('/', $parts['path']);
        $name = array_pop($pieces);
        return $name;
    }

    public function getImageInfo($page) {
        $retval = false;
        $images = parse_array($page, '<img', '>');
        foreach ($images as $image) {
            if (strstr($image, 'class="pic"')) {
                $retval['name'] = $this->getAttribute($image, 'alt');
                $retval['link'] = $this->getAttribute($image, 'src');
            }
        }
        return $retval;
    }

    public function makeDownloadUri($uri) {
        $search = array("http://imgtrex.com/");
        $replace = array('http://raptor.imgtrex.com/i/');
        $new = str_replace($search, $replace, $uri);
        return $new;
    }
}