<?php

/**
 * PiczSiteHelper.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2019
 */

/**
 * Class PiczSiteHelper
 *
 * https://picz.site/img-58ee290e41b6d.html
 * [post: CONTINUE TO IMAGE]
 * https://picz.site/upload/big/2017/04/12/58ee290e41b2f.jpg
 *
 * https://picz.site/img-58ee28ef6205e.html with thumbnail: https://picz.site/upload/small/2017/04/12/58ee28ef62025.jpg
 * https://picz.site/upload/big/2017/04/12/58ee28ef62025.jpg
 * 
 * looks like I can bypass the form post, and request the target image directly by changing the URL to the image, as the URL to the thumbnail and the image are nearly identical.
 */
class PiczSiteHelper extends BaseHelper
{

    /**
     * process
     * @param $uri
     * @return array Return array with 'image' and 'name' as the keys
     */
    public function process($uri) {
        $image['name'] = $this->getImageName($uri);
        if (!$image['name']) {
            return false;
        }
        $image['image'] = $this->getPage($this->image_uri);
        return $image;
    }

    public function getImageName($uri) {
        $parts = explode('"',$uri);
        foreach ($parts as $part) {
            if (strstr($part, 'picz.site/')) {
                $this->image_uri = str_replace('/small/', '/big/',$part);
                $pieces = explode('/', $this->image_uri);
                $name = array_pop($pieces);
                return $name;
            }
        }
    }

    /**
     * looking for this img HTML
     * <img class='centred_resized' src='https://picz.site/upload/big/2017/04/12/58ee290e41b2f.jpg' alt='0000000042.jpg' />
     * @param $page
     * @return bool
     */
    // public function getImageInfo($page) {
    //     $retval = false;
    //     $images = parse_array($page, '<img', '/>');
    //     foreach ($images as $image) {
    //         if (strstr($image, 'https://picz.site/upload/big')) {
    //             $retval['name'] = $this->getAttribute($image, 'alt');
    //             $retval['link'] = $this->getAttribute($image, 'src');
    //         }
    //     }
    //     return $retval;
    // }
    
    /**
     * sendImages
     * This overrides the BaseHelper method
     * with some image hosts, I can determine the URI of the target image by changing the URI to the thumbnail
     * and then request the image directly, bypassing the image host's form post
    */
    public function sendImages() {
        return true;
    }    
}