<?php
    
/**
 * PixxxelsCcHelper.php
 *
 * @version $Id: $
 * @package ripper
 * @copyright 2019
 */

/**
 * we start with a list of URLs like:
 * <a href="https://pixxxels.cc/cgtch5xD" target="_blank"><img src="https://i.pixxxels.cc/cgtch5xD/img_001.jpg" border="0" alt="" /></a> <a href="https://pixxxels.cc/YLczsfjt" target="_blank"><img src="https://i.pixxxels.cc/YLczsfjt/img_002.jpg" border="0" alt="" /></a>
 *
 * then https://pixxxels.cc/cgtch5xD contains something like
 * <a href="https://i.pixxxels.cc/L9pdVSDh/img_001.jpg?dl=1" id="download" data-toggle="tooltip" data-placement="bottom" title="525 x 790 - JPG 110.4 KB" class="btn btn-sm"><i class="fa fa-lg fa-download"></i>Download original image</a>
 *
 * from that I want the URL to the original image:
 * https://i.pixxxels.cc/L9pdVSDh/img_001.jpg?dl=1
 */

class PixxxelsCcHelper extends BaseHelper
{
    
    /**
     * process
     *
     */
    public function process($uri) {
        $page = $this->getPage($uri);
//        $page = file_get_contents('test/detail.pixxxels.cc.html');
        $image = $this->getImageInfo($page);
        $image['image'] = $this->getPage($image['uri']);
        return $image;
    }
    
    public function getImageInfo($page) {
        $links = parse_array($page, '<a href', '</a>');
        $image = array('uri'=>false,'name'=>false);
        if ($links) {
            foreach ($links as $link) {
                $pos = strpos($link, '.jpg?dl=1');
                if ($pos !== false) {
                    // found the link
                    $image['uri'] = $this->getAttribute($link, 'href');
                    $pieces = explode('/', $image['uri']);
                    $last = array_pop($pieces);
                    $image['name'] = str_replace('?dl=1', '', $last);
                }
            }
        }
        return $image;
    }
}
?>