<?php
    
/**
 * RipperUpdater.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2019
 */
    
class RipperUpdater {
    
    protected $verbose = false;
    
    public function upgrade() {
        $manifest = $this->getFile('manifest.json');
        verbose('found these files to update: '. $manifest, $this->verbose);
        $files = json_decode($manifest);

        foreach ($files as $section=>$files) {
            switch ($section) {
                case 'new':
                $rs['new'] = $this->newFiles($files);
                break;
                case 'delete':
                $rs['delete'] = $this->deleteFiles($files);
                break;
                case 'update':
                default:
                $rs['update'] = $this->updateFiles($files);
                break;
            }
        }
        return $rs;
    }
    
    public function getFile($file) {
        return file_get_contents("http://sites.local/ripper-update/".$file);
    }
    
    public function newFiles($files) {
        if (empty($files)) {
            return 'no files to process';
        }
        foreach ($files as $file) {
            
        }
    }
    
    public function deleteFiles($files) {
        if (empty($files)) {
            return 'no files to process';
        }
        foreach ($files as $file) {
            
        }
    }
    
    public function updateFiles($files) {
        if (empty($files)) {
            return 'no files to process';
        }
        foreach ($files as $file) {
            $contents = $this->getFile($file->source);
            verbose('creating a backup of: '. $file->target, $this->verbose);
            copy($file->target, $file->target .'.bak');
            verbose('updating: '. $file->target, $this->verbose);
            $rs[$file->target] = file_put_contents($file->target, $contents);
        }
        return $rs;
    }
    
    public function setVerbose($verbose = false) {
        if ($verbose) {
            $this->verbose = true;
        } else {
            $this->verbose = false;
        }
    }
    
}
    
?>