<?php
/**
 * rip_album.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2019
 */

function rip_album($args, $rip) {
    verbose('grabbing page: '. $args['uri'], $args['verbose']);

    $image_sets = array();
    $html = $rip->getDownloader()->getPageHtml($args['uri']);
    //$sets = parse_array($html, '<div class="postbody">', '</div></div>');
    $sets = parse_array($html, '<blockquote', '</blockquote>');
//    out($sets);
    foreach ($sets as $set) {
        $matches = isImageSet($set);
//        out($matches, false);
        if ($matches) {
            $image_sets[] = $matches;
        }
    }
//    out($image_sets);
    if (count($image_sets) == 0) {
        die('did not find any image sets to process at: '. $args['uri'] .PHP_EOL);
    }

    if(count($image_sets) > 1) {
        $hosts = getHosts($image_sets);
        $host = getArgsSelectHost($hosts);
        $image_set = $image_sets[$host-1];
    } else {
        $image_set = $image_sets[0];
    }
//out($image_set);
    /**
     * $links is a string with the <img> tags embedded within it.
     * if there are multiple <blockquote> sections on the page, this code will only use the first one
     * if the images you want are in a subsequent blockquote, you can use parse_list.php to grab the images
     * @todo someday consider adding code to allow for handling multiple blockquotes, possibly with an additional
     * argument to specify which blockquote to pull images from
     */
//    $links = return_between($html,'<blockquote', '</blockquote>', EXCL);
//out($links);
    verbose('found '. count($image_set) . ' image links.', $args['verbose']);

    /**
     * start with a string of HTML links found on a vipergirls.to page, like:
     * https://vipergirls.to/threads/521577-Anna-AJ-Anna-S-Anna-Sbitna-Anna-Sbitnaya/page24
     *
     * explode the string into pieces to get the URIs to the individual images, like:
     *  http://imgbox.com/lAkZ4Mwd
     *
     * determine which helper class will be used to handle the requests
     *
     * use that URI to get the image name, like:
     *  _MetArt-Spa-cover.jpg
     *
     * manually compute the download link from the URI, like:
     *  https://i.imgbox.com/gwQVgmho.jpg?download=true
     *
     * download the image and save it to the images/ folder
     */
    
    $dest_folder = $rip->getConfigValue('parent_folder'). $args['title'];
    $dest_folder = $rip->setDestFolder($dest_folder);

    verbose('new destination folder will be: '. $dest_folder, $args['verbose']);
    if (!file_exists($dest_folder)) {
        $rs = mkdir($dest_folder);
        $string = $rs ? 'success' : 'FAIL';
        verbose('creating destination folder: '. $string, $args['verbose']);
    }

    $failed = array();

    if ($args['start'] !== 0) {
        $rip->setStart($args['start']);
    }

    if (!empty($failed)) {
        $links = $failed;
    }
    $rs = $rip->process($image_set);
    if (!$rs) {
        $rs = $rip->getFails();
    }
    return $rs;
}

function getHosts($image_sets) {
//    out($image_set);
    foreach ($image_sets as $set) {
        $middle = count($set) / 2;
//        out($set[$middle]); // <a href="https://imgbox.com/EiE5CnGO" target="_blank"><img src="https://thumbs2.imgbox.com/de/a2/EiE5CnGO_t.jpg" border="0" alt="" /></a>
        $pieces = explode('"', $set[$middle]);
//        out($pieces);
        foreach ($pieces as $piece) {
            $pos = strpos($piece, 'http');
            if ($pos !== false) {
                $search = ['http://', 'https://'];
                $replace = [''];
                $trimmed = str_replace($search, $replace, $piece);
                $parts = explode('/', $trimmed);
                $d = explode('.', $parts[0]);
                if (count($d) > 2) {
                    $d = array_reverse($d);
                    $domain = $d[1].'.'.$d[0];
                } else {
                    $domain = $parts[0];
                }
                $retval[] = $domain;
                break;
            }
        }
    }
    return $retval;
}

function getArgsSelectHost($hosts) {
    echo PHP_EOL;
    echo 'Download from which host: '. PHP_EOL;
    $counter = 1;
    foreach ($hosts as $host) {
        echo '['. $counter .'] '. $host . PHP_EOL;
        $counter++;
    }
    echo 'Select host: ';
    $arg = trim(fgets(STDIN));

    if (!$arg) {
        $arg = 1;
    }
    return $arg;
}