<?php
/**
 * rip_collection.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2019
 */

function rip_collection($args, $rip) {
    verbose('grabbing page: '. $args['uri'], $args['verbose']);
    $html = $rip->getDownloader()->getPageHtml($args['uri']);

    $posts = parse_array($html, '<div class="postbody">', '<div class="postfoot">');
    if (!$posts) {
        die('did not find any image sets to download');
    }
    $counter = 1;
    foreach ($posts as $post) {
        if ($args['tag'] == 'bq') {
            $setname = getTitleFromPostBlockquote($post);
        } else {
            $setname = getTitleFromPostH2($post);
        }

        if ($setname == 'DL:') {
            $setname = 'Unknown'.$counter;
        }
        $title = $args['prefix'] . $setname;
        $links = $rip->convertLinks($post);
        $links = $rip->ignoreLink($links);
        if (!$links) {
            $links = array();
        }
        echo '[ '. $counter.' ] '. $title . ' images: '. count($links) .PHP_EOL;
        echo PHP_EOL;
        $results[$counter] = array('title'=>$title, 'links'=>$links);
        $counter++;
    }
    echo 'Enter the set numbers you want to rip, separated by commas.  Enter ALL for all sets.';
    echo PHP_EOL;
    echo 'Which sets to rip? ';
    $args['sets'] = trim(fgets(STDIN));

    if (strtolower($args['sets']) == strtolower('all')) {
        $sets = range(1, count($results));
    } else {
        $sets = explode(',', $args['sets']);
    }

    foreach ($sets as $set) {
        $dest_folder = $rip->getConfigValue('parent_folder') . $results[$set]['title'];
        $dest_folder = $rip->setDestFolder($dest_folder);

        verbose('new destination folder will be: '. $dest_folder, $args['verbose']);
        if (!file_exists($dest_folder)) {
            $rs = mkdir($dest_folder);
            $string = $rs ? 'success' : 'FAIL';
            verbose('creating destination folder: '. $string, $args['verbose']);
        }

        $rs = $rip->processSet($results[$set]);
        if (!$rs) {
            $rs = $rip->getFails();
        }
    }
    return $rs;
}

/**
 * currently assuming title is located in blockquote or H2 like this HTML:
 * <blockquote class="postcontent restore ">
 * 2019-01-03 - Adel C - Snack Time<br />
 */
function getTitleFromPostBlockquote($post) {
    $title = trim(return_between($post, '<blockquote class="postcontent restore ">', '<br />', EXCL));
    $title = strip_tags($title);
    $title = str_replace('&amp;', '&', $title);
    return $title;
}

/**
 * example of the H2 html:
 * <h2 class="title icon">20051231 Jacie My Time (x75) 3000px</h2>
 * @param $post
 * @return mixed|string
 */
function getTitleFromPostH2($post) {
    $title = trim(return_between($post, '<h2 class="title icon">', '</h2>', EXCL));
    $title = strip_tags($title);
    $title = str_replace('&amp;', '&', $title);
    return $title;
}