<?php

function rip_update($arg, $rip)
{
    $current = getCurrentVersion();
    $installed = $rip->getInstalledVersion();
    $compare = version_compare($installed, $current);
    switch ($compare) {
        case '-1':
            echo PHP_EOL;
            echo 'The current version is: ' . $current . PHP_EOL;
            echo 'You are running version: ' . $installed . PHP_EOL;
            echo 'Would you like to update your installation? [y|n]';
            $args['upgrade'] = trim(fgets(STDIN));
            if (strtolower($args['upgrade']) === 'y') {
                require_once 'app/RipperUpdater.php';

                $up = new RipperUpdater();
                $up->setVerbose($rip->getVerbose());
                $rs = $up->upgrade();
                return $rs;
            } else {
                echo 'not performing upgrade' . PHP_EOL;
                exit;
            }
            break;

        case '0':
            echo 'You are running the current version, congratulations!'. PHP_EOL;
            exit;
            break;

        case '1':
            displayError(['Somehow you are running a more recent version than the current version']);
            break;

        default:
            displayError(['Comparing versions failed']);
            break;
    }
}

function getCurrentVersion()
{
    $version = file_get_contents("http://sites.local/ripper-update/version.txt");
    return $version;
}

?>